#include <stdio.h>
#include <stdlib.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <winsock2.h>
#include <commctrl.h>
#include <string.h>
#include "c4p4ares.h"

#define WM_POLACZENIE   (WM_USER + 100)

static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);

SOCKET ss;
char Sender[256];
char SingleLine[1025];
unsigned long CurrStep = 0L;

void ReadLineFromNetwork(HWND hwndDlg)
{
    SOCKET s;
    struct sockaddr_in incoming;
    int alen = sizeof(struct sockaddr_in);
    int toread, rd, offset;
    HWND listbox;

    KillTimer(hwndDlg, 0);
    s = accept(ss, (struct sockaddr*) &incoming, &alen);
    if (s == INVALID_SOCKET) {
        MessageBox(
            NULL, 
            "accept nie powiodl sie (INVALID_SOCKET)",
            "c4p1a",
            0);
        SetTimer(hwndDlg, 0, 100, NULL);
        return;
    }
    memset(SingleLine, 0, 1025);
    toread = 0;
    while(recv(s, (char*) &toread, 4, 0) <= 0);
    toread = ntohl(toread);
    offset = 0;
    while (toread > 0) {
        rd = recv(s, SingleLine+offset, toread, 0);
        offset += rd;
        toread -= rd;
    }
    closesocket(s);
    sprintf(Sender,"Wiadomosc od %s:",inet_ntoa(incoming.sin_addr));
    listbox = GetDlgItem(hwndDlg, IDC_LIST_KOMUNIKATY);
    SendMessage(listbox, LB_ADDSTRING, 0, (LPARAM) Sender);
    SendMessage(listbox, LB_ADDSTRING, 0, (LPARAM) SingleLine);
    UpdateWindow(listbox);
    SetTimer(hwndDlg, 0, 100, NULL);
}


int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS wc;
    unsigned short port;
    struct sockaddr_in addr;
    WORD RequiredVersion;
    WSADATA WD;

    port = atoi(lpCmdLine);
    if (port == 0) {
        MessageBox(NULL,"Naley poda prawidowy numer portu jako parametr w wierszu polece.","p3_s",0);
        return 1;
    }

    RequiredVersion = MAKEWORD(2, 0);
    if (WSAStartup(RequiredVersion, &WD) != 0) {
        MessageBox(NULL,"Inicjalizacja biblioteki WinSock 2 nie powioda si.","p3_s",0);
        return 1;
    }

    port = htons(port);
    addr.sin_family = AF_INET;
    addr.sin_port = port;
    addr.sin_addr.s_addr = INADDR_ANY;

    ss = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    bind(ss, (struct sockaddr*) &addr, sizeof(addr));
    listen(ss, 10);

    memset(&wc,0,sizeof(wc));
    wc.lpfnWndProc = DefDlgProc;
    wc.cbWndExtra = DLGWINDOWEXTRA;
    wc.hInstance = hinst;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    wc.lpszClassName = "c4p1a";
    RegisterClass(&wc);
    InitCommonControls();

    DialogBox(hinst, MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, (DLGPROC) DialogFunc);

    closesocket(ss);
    WSACleanup();
    return 0;

}

static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{
    WSAAsyncSelect(ss, hDlg, WM_POLACZENIE, FD_ACCEPT);
    SetTimer(hDlg, 0, 100, NULL);
    return 1;
}

static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg) {
    case WM_INITDIALOG:
        InitializeApp(hwndDlg,wParam,lParam);
        return TRUE;
    case WM_COMMAND:
        switch (LOWORD(wParam)) {
            case IDOK:
                EndDialog(hwndDlg,1);
                return 1;
            case IDCANCEL:
                EndDialog(hwndDlg,0);
                return 1;
        }
        break;
    case WM_CLOSE:
        EndDialog(hwndDlg,0);
        return TRUE;

    case WM_TIMER:
        SendMessage(GetDlgItem(hwndDlg, IDC_PROGRESS), PBM_STEPIT, (WPARAM) 0, (LPARAM) 0);
        SetTimer(hwndDlg, 0, 150, NULL);
        break;

    case WM_POLACZENIE:
        ReadLineFromNetwork(hwndDlg);
    }
    return FALSE;
}
